<?php

 /**
  * @file
  *
  * Code for displaying the weather page.
  */

/**
 *
 * Implements hook_form().
 */
function weather_block_page_form() {

  $locations = array();

  $array = taxonomy_vocabulary_get_names();

  if (arg(0) == 'weather') {
    $values = taxonomy_get_tree($array['weather_locations']->vid);
  }
  if (arg(0) == 'world_weather') {
    $values = taxonomy_get_tree($array['weather_locations_foreign']->vid);
  }

  foreach ($values as $tid) {

    // Check whether the taxonomy term is published or not and if it is, add to the menu
    $entity = entity_load('taxonomy_term', array($tid->tid));

    foreach ($entity as $val) {
      if ($val->status != 0) {
        $locations[$tid->tid] = $tid->name;
      }
    }
  }

  if (arg(0) == 'weather') {
    if (isset($_SESSION['selected_weather_location'])) {
      if (taxonomy_term_load($_SESSION['selected_weather_location']) != NULL) {
        $location = $_SESSION['selected_weather_location'];
      }
      else {
        $location = variable_get('weather_location');
      }
    }
    else {
      $location = variable_get('weather_location');
    }
  }

  if (arg(0) == 'world_weather') {
    if (isset($_SESSION['selected_weather_location_world'])) {
      if (taxonomy_term_load($_SESSION['selected_weather_location_world']) != NULL) {
        $location = $_SESSION['selected_weather_location_world'];
      }
      else {
        $location = variable_get('weather_location_world');
      }
    }
    else {
      $location = variable_get('weather_location_world');
    }
  }

  $form['weather_location'] = array(
    '#type' => 'select',
    '#title' => t('Select city'),
    '#default_value' => $location,
    '#options' => $locations,
    '#required' => FALSE,
  );

  $form['weather_location_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Change location'),
  );

  return $form;
}

/**
 * Implements hook_form_submit().
 */
function weather_block_page_form_submit(&$form, $form_state) {

  if (arg(0) == 'weather') {
    $_SESSION['selected_weather_location'] = $form_state['values']['weather_location'];
  }
  if (arg(0) == 'world_weather') {
    $_SESSION['selected_weather_location_world'] = $form_state['values']['weather_location'];
  }
}

/**
 * Function for creating the page for a weather display for cities other than the default.
 */
function weather_block_page() {

  if (arg(0) == 'weather') {
    if (isset($_SESSION['selected_weather_location'])) {
      if (taxonomy_term_load($_SESSION['selected_weather_location']) != NULL) {
        $location = taxonomy_term_load($_SESSION['selected_weather_location']);
      }
      else {
        $location = taxonomy_term_load(variable_get('weather_location'));
      }
    }
    else {
      $location = taxonomy_term_load(variable_get('weather_location'));
    }
  }

  if (arg(0) == 'world_weather') {
    if (isset($_SESSION['selected_weather_location_world'])) {
      if (taxonomy_term_load($_SESSION['selected_weather_location_world']) != NULL) {
        $location = taxonomy_term_load($_SESSION['selected_weather_location_world']);
      }
      else {
        $location = taxonomy_term_load(variable_get('weather_location_world'));
      }
    }
    else {
      $location = taxonomy_term_load(variable_get('weather_location_world'));
    }
  }

  $services = variable_get('weather_services');

  foreach ($services as $key => $val) {
    if ($key == variable_get('weather_service')) {
      $key = 'field_' . $key;

      $location_id = $location->$key;
    }
  }

  $weather = new Weather($location_id['und'][0]['value'], variable_get('weather_service'));

  if (variable_get('weather_service') == 'weather_com') {
    $content = $weather->fiveDayForecast();
  }
  elseif (variable_get('weather_service') == 'yahoo_weather') {
    $data = $weather->otherCities();

    if (variable_get('weather_display_units') == 0) {
      $scale = t('&deg;C');
    }
    else {
      $scale = t('&deg;F');
    }

    $path = base_path() . drupal_get_path('module', 'weather_block');

    foreach ($data as $key => $val) {
      if (variable_get('weather_use_provider_weather_icons') == 1) {
        $icon = "http://l.yimg.com/a/i/us/we/52/" . $val['code'] . ".gif";
      }
      else {
        $icon = $path . "/weather-icons/" . $val['code'] . ".png";
      }

      $content[$key]['icon'] = check_plain($icon);

      if ($key == 0) {
        $content[$key]['current'] = check_plain($val['temp']) . " " . $scale;
        $content[$key]['day'] = t('Current weather');

        if (variable_get('weather_display_wind_yahoo_weather', 1) == 1) {
          $content[$key]['wind'] = "<div class='weather_wind'><div class='weather_wind_direction'>" . t('Wind');

          $imgpath = $path . "/weather-icons/wind/" . $val['wind']['direction'] . ".png";

          $content[$key]['wind'] .= " " . round(check_plain($weather->general->wind->attributes()->speed)) . " " . check_plain($weather->general->units->attributes()->speed) . "</div></div>";
        }

        if (variable_get('weather_display_humidity_yahoo_weather', 1) == 1) {
          $content[$key]['humidity'] = check_plain($val['humidity']) . "%";
        }
      }
      else {

        $content[$key]['low'] = check_plain($val['temp']['low']) . " " . $scale;
        $content[$key]['high'] = check_plain($val['temp']['high']) . " " . $scale;

        switch ($val['day']) {
          case 'Mon':
            $day = 'Monday';
          break;
          case 'Tue':
            $day = 'Tuesday';
          break;
          case 'Wed':
            $day = 'Wednesday';
          break;
          case 'Thu':
            $day = 'Thursday';
          break;
          case 'Fri':
            $day = 'Friday';
          break;
          case 'Sat':
            $day = 'Saturday';
          break;
          case 'Sun':
            $day = 'Sunday';
          break;
        }

        $content[$key]['day'] = t($day);
      }
    }
  }
  elseif (variable_get('weather_service') == 'world_weather_online') {

    if (variable_get('weather_display_units') == 0) {
      $scale = t('&deg;C');
    }
    else {
      $scale = t('&deg;F');
    }

    $content[0]['day'] = "<div class='forecast_day_wrapper'>" . t('Current conditions') . "</div>";

    if (variable_get('weather_display_units') == 0) {
      $deg_low = $weather->xml->current_condition->temp_C;
    }
    else {
      $deg_low = $weather->xml->current_condition->temp_F;
    }

    $content[0]['low'] = check_plain($deg_low) . " " . $scale;

    if (date('G') < 9 || date('G') > 21) {
      $content[0]['icon'] = "http://c358489.r89.cf1.rackcdn.com/images/weather/small/" . check_plain($weather->xml->current_condition->weatherCode) . "_night_sm.png";
    }
    else {
      $content[0]['icon'] = "http://c358489.r89.cf1.rackcdn.com/images/weather/small/" . check_plain($weather->xml->current_condition->weatherCode) . "_day_sm.png";
    }

    $content[0]['humidity'] = check_plain($weather->xml->current_condition->humidity) . "%";

    if (variable_get('weather_display_units', 0) == 0) {
      $wind = round((int) $weather->xml->current_condition->windspeedKmph * 1000 / 3600) . " m/s";
    }
    else {
      $wind = $weather->xml->current_condition->windspeedMiles . " mph";
    }

    $content[0]['wind'] = t(check_plain($weather->xml->current_condition->winddir16Point) . " at " . check_plain($wind));

    $i = 1;

    foreach($weather->xml->weather as $key => $val) {

      $content[$i]['day'] = "<div class='forecast_day_wrapper'>" . t(date('l', strtotime($val->date))) . "</div>";
 
      if (variable_get('weather_display_units') == 0) {
        $deg_low = $val->tempMinC;
      }
      else {
        $deg_low = $val->tempMinF;
      }

      $content[$i]['low'] = check_plain($deg_low) . " " . $scale;

      if (variable_get('weather_display_units') == 0) {
        $deg_high = $val->tempMaxC;
      }
      else {
        $deg_high = $val->tempMaxF;
      }

      $content[$i]['high'] = check_plain($deg_high) . " " . $scale;

      if (variable_get('weather_display_units', 0) == 0) {
        $wind = round((int) $val->windspeedKmph * 1000 / 3600) . " m/s";
      }
      else {
        $wind = $val->windspeedMiles . " mph";
      }

      $content[$i]['wind'] = t(check_plain($val->winddir16Point) . " at " . check_plain($wind));

      $content[$i]['icon'] = "http://c358489.r89.cf1.rackcdn.com/images/weather/small/" . check_plain($val->weatherCode) . "_day_sm.png";

      $i++;
    }
  }
  else {
  }

  $menu = $weather->menu();

  $form = drupal_get_form('weather_block_page_form');

  cache_clear_all();

  return theme('weather_block_local_weather', array('content' => $content, 'menu' => $menu, 'location' => $location, 'form' => $form, 'service' => variable_get('weather_service')));
}
